#include "guimodule.h"
#include "windows.h"
#include <stdio.h>
#include <assert.h>

GuiModule::GuiModule(seGuiCallback seaudioMaster, void *p_resvd1) : SEGUI_base(seaudioMaster, p_resvd1)
,m_inhibit_update(false)
{
}

GuiModule::~GuiModule(void)
{
}

void GuiModule::Initialise(bool loaded_from_file)
{
	SEGUI_base::Initialise(loaded_from_file);

	RegisterPatchParameter();

	if( !loaded_from_file )
	{
		AddGuiPlug( DT_BOOL, DR_IN, "Gate" );
		AddGuiPlug( DT_FLOAT, DR_IN, "Reset Value" );
		AddGuiPlug( DT_FLOAT, DR_OUT, "Value" );
	}
	
	resetvalue = 0;

	OnValueChanged(); // initial value
}

void GuiModule::RegisterPatchParameter()
{
}

void GuiModule::OnGuiPinValueChange(SeGuiPin *p_pin)
{
	OnValueChanged();
}

void GuiModule::OnValueChanged()
{
	int gatebutton = getPin( 0 )->getValueInt();	
	resetvalue = getPin( 1 )->getValueFloat();

	if ( gatebutton != 0 )
	{
		getPin( 2 )->setValueFloat(resetvalue);		
	}
	gatebutton = 0;
}


float GuiModule::StringToFloat(const SeSdkString &p_string)
{
	char * temp;	// convert string to float
	return (float) strtod( p_string.data(), &temp );
}


void GuiModule::OnModuleMsg(int p_length, void * p_data)
{/*
	assert( p_length == sizeof(values) );
	memcpy(values,p_data,p_length);

	// aknowledge
	int h = Handle();
	char *msg = "ack";
	int size = 3;
////////////// EXPERIMENTAL ////////////
SendStringToAudio( 4, &h );
SendStringToAudio( 4, &size );
SendStringToAudio( size, msg );
///////////////////////////////////////

	InvalidateControl();*/
}

void GuiModule::SendStringToAudio( int p_length, void *p_data )
{
	CallHost(seGuiHostSendStringToAudio, p_length, 0, p_data );
}

int GuiModule::Handle(void)
{
	return CallHost(seGuiHostGetHandle);
}




